diff --git a/src/lib-dcrypt/Makefile.am b/src/lib-dcrypt/Makefile.am
index f9c7c2a..6d8b5d7 100644
--- a/src/lib-dcrypt/Makefile.am
+++ b/src/lib-dcrypt/Makefile.am
@@ -20,9 +20,9 @@ libdcrypt_la_CFLAGS = $(AM_CPPFLAGS) \
 if BUILD_DCRYPT_OPENSSL
 pkglib_LTLIBRARIES += libdcrypt_openssl.la
 libdcrypt_openssl_la_SOURCES = dcrypt-openssl.c
-libdcrypt_openssl_la_LDFLAGS = -module -avoid-version -shared ../lib-ssl-iostream/libdovecot_openssl_common.la ../lib/liblib.la
+libdcrypt_openssl_la_LDFLAGS = -module -avoid-version ../lib-ssl-iostream/libssl_iostream_openssl.la
 libdcrypt_openssl_la_LIBADD = $(SSL_LIBS)
-libdcrypt_openssl_la_DEPENDENCIES = ../lib-ssl-iostream/libdovecot_openssl_common.la ../lib/liblib.la
+libdcrypt_openssl_la_DEPENDENCIES = ../lib-ssl-iostream/libssl_iostream_openssl.la
 libdcrypt_openssl_la_CFLAGS = $(AM_CPPFLAGS) \
 	$(SSL_CFLAGS)
 endif
@@ -53,6 +53,7 @@ check-test: all-am
 	done
 
 LIBDOVECOT_TEST_DEPS = \
+	../lib-ssl-iostream/libssl_iostream.la \
 	../lib-test/libtest.la \
 	../lib/liblib.la
 LIBDOVECOT_TEST = \
diff --git a/src/lib-dcrypt/test-crypto.c b/src/lib-dcrypt/test-crypto.c
index eb76b5a..40e290d 100644
--- a/src/lib-dcrypt/test-crypto.c
+++ b/src/lib-dcrypt/test-crypto.c
@@ -755,10 +755,11 @@ int main(void) {
 	struct dcrypt_settings set = {
 		.module_dir = ".libs"
 	};
+	const char *error;
 
 	random_init();
-	if (!dcrypt_initialize(NULL, &set, NULL)) {
-		i_error("No functional dcrypt backend found - skipping tests");
+	if (!dcrypt_initialize(NULL, &set, &error)) {
+		i_error("No functional dcrypt backend found - skipping tests: %s", error);
 		return 0;
 	}
 
diff --git a/src/lib-ssl-iostream/Makefile.am b/src/lib-ssl-iostream/Makefile.am
index b8fd57a..f6cb95a 100644
--- a/src/lib-ssl-iostream/Makefile.am
+++ b/src/lib-ssl-iostream/Makefile.am
@@ -10,14 +10,10 @@ AM_CPPFLAGS = \
 if BUILD_OPENSSL
 module_LTLIBRARIES = libssl_iostream_openssl.la
 
-noinst_LTLIBRARIES += libdovecot_openssl_common.la
-libdovecot_openssl_common_la_LIBADD = $(SSL_LIBS)
-libdovecot_openssl_common_la_SOURCES = \
-	dovecot-openssl-common.c
-
 libssl_iostream_openssl_la_LDFLAGS = -module -avoid-version
-libssl_iostream_openssl_la_LIBADD = libdovecot_openssl_common.la $(SSL_LIBS)
+libssl_iostream_openssl_la_LIBADD = $(SSL_LIBS)
 libssl_iostream_openssl_la_SOURCES = \
+	dovecot-openssl-common.c \
 	iostream-openssl.c \
 	iostream-openssl-common.c \
 	iostream-openssl-context.c \
@@ -26,8 +22,7 @@ libssl_iostream_openssl_la_SOURCES = \
 endif
 
 libssl_iostream_la_SOURCES = \
-	iostream-ssl.c \
-	$(ssl_sources)
+	iostream-ssl.c
 
 noinst_HEADERS = \
 	dovecot-openssl-common.h
